{Diese Unit enthlt die Definitiun eines Addresseintrags (die Klasse TAddress)}
unit Address;

interface

type

{Instanzen dieser Klasse sollen Addresseintrge reprsentieren}
TAddress = class
private
{die eigentlichen Variablen sind 'private' und damit nach auen hin nicht
sichtbar, der Nutzer dieser Klasse, kann die 'private'-deklarierten Felder und
Methoden nicht benutzen}

{drei Strings zur Aufnahme von Nachname, Vorname, und Adresse}
  Name,Firstname,Address:string;
public
{die Methoden um auf die Variablen zuzugreifen (lesen und schreiben) werden
'public' deklariert, damit der Nutzer der Klasse sie verwenden kann}
  function getName:string; {liefert den Nachnamen zurck}
  function getFirstname:string; {liefert Vornamen zurck}
  function getAddress:string; {liefert Address-String zurck}
  procedure setName(aName:string); {setzt den Nachnamen}
  procedure setFirstname(aFirstname:string); {setzt den Vornamen}
  procedure setAddress(aAddress:string); {setzt den Address-String}

  procedure WriteToFile(var F:File);
  procedure ReadFromFile(var F:File);
end;

implementation
{es folgt die Implementation der oben angekndigten Methoden}

{liefert den Nachnamen zurck}
function TAddress.getName:string;
begin
  getName:=Name;
end;

{liefert den Vornamen zurck}
function TAddress.getFirstname:string;
begin
  getFirstname:=Firstname;
end;

{liefert den Address-String zurck}
function TAddress.getAddress:string;
begin
  getAddress:=Address;
end;

{setzt den Nachnamen}
procedure TAddress.setName(aName:string);
begin
  Name:=aName;
end;

{setzt den Vornamen}
procedure TAddress.setFirstname(aFirstname:string);
begin
  Firstname:=aFirstname;
end;

{setzt den Address-String}
procedure TAddress.setAddress(aAddress:string);
begin
  Address:=aAddress;
end;

{schreibt dieses Address-Objekt in die Datei, die F zugeordnet ist. Die Datei
mu fr Schreibzugriffe geffnet sein}
procedure TAddress.WriteToFile(var F:File);
var L:Integer;
begin
{da es keinen einfach Mechanismus gibt, Daten variabler Gre (z.B. Strings) in
Dateien zu schreiben, mu man sich selbst helfen:
- zuerst die Lnge des zu schreibenden Strings ermitteln
- +diese Zahl in die Datei schreiben
- den String hinter die Zahl schreiben, sofern er Zeichen enthlt
Achtung: Es mu String[1] bergeben werden, da erst hier die eigentlichen
Zeichen des Strings anfangen}
  L:=Length(Name); {Name schreiben}
  BlockWrite(F,L,SizeOf(L));
  if L>0 then BlockWrite(F,Name[1],L);

  L:=Length(Firstname); {Vorname schreiben}
  BlockWrite(F,L,SizeOf(L));
  if L>0 then BlockWrite(F,Firstname[1],L);

  L:=Length(Address); {Adre-String schreiben}
  BlockWrite(F,L,SizeOf(L));
  if L>0 then BlockWrite(F,Address[1],L);
end;

{liest einen Address-Eintrag aus der Datei, die der bergebenen Dateivariable F
zugeorndet ist. Die Datei mu fr Lesezugriffe offen sein.}
procedure TAddress.ReadFromFile(var F:File);
var L:Integer;
begin
{Das Vorgehen orientiert sich am Reinschreiben der Daten (die Daten mssen in
der gleichen Reihenfolge wieder gelesen werden
- zuerst die Lnge des aktuellen Strings in der Datei ermitteln (wurde ja vorher
  reingeschrieben
- falls Lnge=0 dann Leerstring sonst, Stringlnge setzen und String auslesen
Achtung: Auch hier mu wieder String[1] bergeben werden damit die Daten im
Zeichenbereich des Strings landen}

  BlockRead(F,L,SizeOf(L)); {Name lesen}
  if L=0 then Name:='' else begin
    SetLength(Name,L);BlockRead(F,Name[1],L);
  end;

  BlockRead(F,L,SizeOf(L)); {Vorname lesen}
  if L=0 then Firstname:='' else begin
    SetLength(Firstname,L);BlockRead(F,Firstname[1],L);
  end;

  BlockRead(F,L,SizeOf(L)); {Adre-String lesen}
  if L=0 then Address:='' else begin
    SetLength(Address,L);BlockRead(F,Address[1],L);
  end;
end;

end.
